/**
 * @author Immo Schulz-Gerlach
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.1
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class ActivityBorder extends com.umlet.element.base.Entity {

  // Change this method if you want to edit the graphical 
  // representation of your custom element.
  public void paint(Graphics g) {

    // Some unimportant initialization stuff; setting color, font 
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    Constants.getFRC(g2);



    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		
		Composite[] composites = colorize(g2); //LME: enable colors

		//g2.setComposite(composites[1]);
		//g2.setColor(_fillColor);
		//g2.fillRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,Constants.getFontsize()*2, Constants.getFontsize()*2);
		g2.setComposite(composites[0]);
		if(_selected)
			g2.setColor(_activeColor);
		else
			g2.setColor(_deselectedColor);
		g2.drawRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,Constants.getFontsize()*2, Constants.getFontsize()*2);
		
    int yPos=Constants.getDistLineToText();
    int yZeile2=0;
    int xPrePost=50; //Mindest-Einrckung fr Pre- und Postcondition (insb. falls kein weiterer Text linksbndig unter dem Titel steht)

    Vector<String> pre= new Vector<String>();
    Vector<String> post= new Vector<String>();
    for (int i=0; i<tmp.size(); i++) {
      String s=(String)tmp.elementAt(i);
      if (i==0) {
	      Font bold = Constants.getFont().deriveFont(Font.BOLD);
	      g2.setFont(bold); //Erste Zeile: ActivityName => Fettdruck.
      }
      if (s.startsWith("pre="))
	      pre.addElement(s.substring(4).trim());
      else if (s.startsWith("post="))
	      post.addElement(s.substring(5).trim());
      else { //Text ausgeben
	      yPos+=Constants.getFontsize();
	      Constants.write(g2,s,Constants.getFontsize(), yPos, false);
	      yPos+=Constants.getDistTextToText();
	      if (i != 0) //Erste Zeile mit Diagrammnamen nicht mitzhlen, Pre/Post ohnehin erst ab Zeile 2 ausgegeben werden
		xPrePost = Math.max(xPrePost, Constants.getPixelWidth(g2,s+"XXX"));
      }
      if (i==0) {
	      g2.setFont(Constants.getFont()); //Weitere Zeilen wieder in normaler Schrift (nicht fett)
	      yPos += Constants.getDistLineToText(); //Mehr Abstand zwischen ActivityName und Rest.
	      yZeile2=yPos + Constants.getFontsize();
      }
    }
    //Finally: Pre und Postcondition ausgeben
    yPos=yZeile2;
    int xCondition = xPrePost + Constants.getPixelWidth(g2,"<postcondition>>");
    
    Iterator<String> it = pre.iterator();
    if (it.hasNext()) {
	Constants.write(g2,"<<precondition>>", xPrePost, yPos, false);
	while (it.hasNext()) {
		Constants.write(g2, it.next(), xCondition, yPos, false);
		yPos += Constants.getDistTextToText()+Constants.getFontsize();
	}
    }
    it = post.iterator();
    if (it.hasNext()) {
	Constants.write(g2,"<<postcondition>>", xPrePost, yPos, false);
	while (it.hasNext()) {
		Constants.write(g2, it.next(), xCondition, yPos, false);
		yPos += Constants.getDistTextToText()+Constants.getFontsize();
	}
    }

  }


  // Change this method if you want to set the resize-attributes of
  // your custom element
  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
  }


  // Advanced: change this method to modify the area where relations
  // stick to your custom element.
  public StickingPolygon getStickingBorder() {
    // By default, the element returns its outer borders. Change it,
    // if your element needs to stick to relations differently.
    // See, for example, the source code of the UML interface element.
    return null;
  }
}
