/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
 
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class BigState extends com.umlet.element.custom.State {

	public void paint(Graphics g) {
		
		Graphics2D g2=(Graphics2D) g;
		g2.setFont(Constants.getFont());
		Constants.getFRC(g2);
		
		Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		
		Composite[] composites = colorize(g2); //LME: enable colors
		//g2.setColor(_activeColor);
		
		boolean valign=true, bold=false, stroke=false;
		int yPos;
		
		
		int i=0;
		while(i<tmp.size())
		{
			String StrTmp = (String) tmp.elementAt(i);
			if(StrTmp.equals("boldBorder"))
			{
				bold=true;
				tmp.remove(i);
			}
			
			else if(StrTmp.startsWith("lt="))
			{
				if(StrTmp.contains("."))
					stroke=true;
				
				if(StrTmp.contains("..") || StrTmp.contains("--") || StrTmp.contains("b"))
					bold=true;
					
				tmp.remove(i);
			}
			
			else if(StrTmp.equals("topvalign"))
			{
				valign=false;
				tmp.remove(i);
			}
			else
				i++;
		}
		
		//look if there is any vertical alignment
		if(valign)
			yPos=this.getHeight()/2-tmp.size()*(Constants.getFontsize()+Constants.getDistTextToText())/2;
		else
			yPos=0;
		
		//draw the (bold) round Rectangle
		if(bold && stroke)
			g2.setStroke(Constants.getStroke(1,2));
		else if(!bold && stroke)
			g2.setStroke(Constants.getStroke(1,1));
		else if(bold && !stroke)
			g2.setStroke(Constants.getStroke(0,2));
		
		g2.setComposite(composites[1]);
		g2.setColor(_fillColor);
		g2.fillRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,30,30);
		g2.setComposite(composites[0]);
		if(_selected)
			g2.setColor(_activeColor);
		else
			g2.setColor(_deselectedColor);
		g2.drawRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,30,30);
		g2.setStroke(Constants.getStroke(0,1));
		//if(bold)
		//	g2.drawRoundRect(1,1,this.getWidth()-3,this.getHeight()-3,29,29);
		

		for (i=0; i<tmp.size(); i++) {
			String s = (String) tmp.elementAt(i);
			yPos+=Constants.getFontsize();
			
			if(!s.equals("--"))
			{
				if(s.startsWith("leftalign="))
				{
					Constants.write(g2,s.substring(10),Constants.getFontsize()/2, yPos, false);
				}
				else
					Constants.write(g2,s,(int)this.getWidth()/2, yPos, true);
			}
			else
				g2.drawLine(0, yPos, this.getWidth()-1, yPos);
			
			yPos+=Constants.getDistTextToText();
		}

		
	}

}
