/**
 * @author Immo Schulz-Gerlach
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class ClassIcon extends com.umlet.element.base.Entity {
  
  private final int CONTROL=1;
  private final int BOUNDARY=2;
  private final int ENTITY=3;
  private final int NOKIND=0;
  
  private int kind= NOKIND;
  private int h=0; //Hoehe und Breite des Kreises
  private int y=0; //y-Offset zum oberen Rand des Kreises
  //Beide gesetzt in paint, ausgewertet auch ingetStickingBorder

  // Change this method if you want to edit the graphical
  // representation of your custom element.
  public void paint(Graphics g) {

    // Some unimportant initialization stuff; setting color, font
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    Constants.getFRC(g2);


    // It's getting interesting here:
    // First, the strings you type in the element editor are read and
    // split into lines.
    // Then, by default, they are printed out on the element, aligned
    // to the left.
    // Change this to modify this default text printing and to react
    // to special strings
    // (like the "--" string in the UML class elements which draw a line).
    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		
		Composite[] composites = colorize(g2); //LME: enable colors
		g2.setColor(_activeColor);
		
    //int yPos=Constants.getDistLineToText();
    int yPos=this.getHeight()-Constants.getDistLineToText();
    int xMid=this.getWidth() / 2;
      for (int i=tmp.size()-1; i>=0; i--) {
        String s=(String)tmp.elementAt(i);
        if (s.startsWith("icon=")) {
          s = s.substring(5).trim();
          if (s.equals(">") || s.equalsIgnoreCase("control")) kind = CONTROL;
          else if (s.equals("_") || s.equalsIgnoreCase("entity")) kind = ENTITY;
          else if (s.equals("|") || s.equals("T") || s.equalsIgnoreCase("boundary")) kind = BOUNDARY;          
        } 
        else {
          Constants.write(g2,s,xMid, yPos, true);
          yPos-=Constants.getDistTextToText() + Constants.getFontsize();
        }
      }


    // Finally, change other graphical attributes using
    // drawLine, getWidth, getHeight..
    if (_selected) {
      g2.drawLine(0,0,this.getWidth()-1,0);
      g2.drawLine(this.getWidth()-1, 0, this.getWidth()-1, this.getHeight()-1);
      g2.drawLine(this.getWidth()-1, this.getHeight()-1, 0, this.getHeight()-1);
      g2.drawLine(0, this.getHeight()-1, 0, 0);
    }

    h = yPos - Constants.getDistLineToText(); //Gesamthoehe fuer Symbol
    y = h / 5; //Soviel Platz nach oben lassen, fr Pfeil von Kontrollklasse. (1/5)
    int c = h / 10; //Fuer Pfeil
    h = h - y; //Neue Hoehe abzueglich eben berechnetem Rand. Gleichzeitig auch Breite.
    int x = (this.getWidth() - h) / 2;
    g2.drawOval(x,y,h,h);
    
    switch (kind) {
      case BOUNDARY: 
        int my = y + (h/2);
        int xl = x - y;
        g2.drawLine(x,my,xl,my);
        g2.drawLine(xl,2*y,xl,h);
        break;
      case ENTITY:
        g2.drawLine(x,y+h,x+h,y+h);
        break;
      case CONTROL:
        int m = this.getWidth() / 2;
        g2.drawLine(m,y,m-c,y+c);
        g2.drawLine(m,y,m-c,y-c);
        break;
      default: 
        Constants.write(g2," icon=\"_\",\">\" or \"|\" missing ",0, Constants.getFontsize(), false);
    }
    
  }


  // Change this method if you want to set the resize-attributes of
  // your custom element
  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
  }


  // Advanced: change this method to modify the area where relations
  // stick to your custom element.
  public StickingPolygon getStickingBorder() {
    // By default, the element returns its outer borders. Change it,
    // if your element needs to stick to relations differently.
    // See, for example, the source code of the UML interface element.
    StickingPolygon p = new StickingPolygon();
    int li=0;
    int re=this.getWidth()-1;
    if (h > 0){
      li = (this.getWidth()-h)/2;
      if (kind==BOUNDARY) li -= y;
      re = (this.getWidth()+h)/2;
    }
    Point ol = new Point(li,y);
    Point or = new Point(re,y);
    Point ul = new Point(li,this.getHeight()-1);
    Point ur = new Point(re,this.getHeight()-1);
    p.addLine(ol, or, Constants.RESIZE_TOP);
    p.addLine(or, ur, Constants.RESIZE_RIGHT);
    p.addLine(ur ,ul, Constants.RESIZE_BOTTOM);
    p.addLine(ul, ol, Constants.RESIZE_LEFT);
    return p;
  }
}
