import java.awt.*;
import java.util.*;

import com.umlet.control.*;
import com.umlet.element.base.*;

/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */

public class ExpansionNode extends com.umlet.element.base.Entity {
  public Entity CloneFromMe() {
    ExpansionNode c=new ExpansionNode();
    c.setState(this.getPanelAttributes());
    //c.setVisible(true);
    c.setBounds(this.getBounds());
    return c;
  }
  public ExpansionNode(String s) {
    super(s);
  }
  public ExpansionNode() {
    super();
  }

  private Vector<String> getStringVector() {
    Vector<String> ret=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
    return ret;
  }

  public void paint(Graphics g) {
    Graphics2D g2=(Graphics2D) g;
    g2.setFont(Constants.getFont());

    Constants.getFRC(g2);
		
		Vector<String> tmp=new Vector<String>(getStringVector());
		Composite[] composites = colorize(g2); //LME: enable colors
		g2.setColor(_activeColor);

    /*FontRenderContext rendering;
    if (Constants.getFontsize()>12) {
         rendering=new FontRenderContext(null, true, true);
         g2.setRenderingHints(Constants.UxRenderingQualityHigh());
    } else {
         rendering=new FontRenderContext(null, false, false);
         g2.setRenderingHints(Constants.UxRenderingQualityLow());
    }*/

		//white box background
		g2.setColor(_fillColor);
		Rectangle r=this.getBounds();
		g.fillRect(0,0,(int)r.getWidth()-1,(int)r.getHeight()-1);
		//set the color for frames
		g2.setColor(_activeColor);
		
    
		
    if (tmp.contains("lt=.")) {
      tmp.remove("lt=.");
      g2.setStroke(Constants.getStroke(1,1));
    }

    int yPos=this.getHeight()/2-tmp.size()*(Constants.getFontsize()+Constants.getDistTextToText())/2;

    int i, j, hcount=0, vcount=0;
		
    for (i=0; i<tmp.size(); i++) {
      String s=tmp.elementAt(i);
			
			for(j=0;j<s.length();j++)
			{
				if(s.charAt(j) == '-')
					hcount++;
				else if(s.charAt(j) == '|')
					vcount++;
			}
			//~ else 
			//~ {
        //~ yPos+=Constants.getFontsize();
        //~ if (CENTER) {
          //~ Constants.write(g2, s, (int)this.getWidth()/2, yPos, true);
        //~ } else {
          //~ Constants.write(g2, s, Constants.getFontsize()/2, yPos, false);
        //~ }
        //~ yPos+=Constants.getDistTextToText();
      //~ }
    }


    g.drawRect(0,0,(int)r.getWidth()-1,(int)r.getHeight()-1);
		
		//do the vertical lines
		for(i=1;i<=vcount;i++)
			g2.drawLine(this.getWidth() / (vcount+1) *i,0,this.getWidth() / (vcount+1) *i,(int)r.getHeight()-1);
		//do the horizontal lines
		for(i=1;i<=hcount;i++)
			g2.drawLine(0,this.getHeight() / (hcount+1) *i,(int)r.getWidth()-1,this.getHeight() / (hcount+1) *i);
    /*if (_selected) {
      g.drawOval(1,1,(int)r.getWidth()-3,(int)r.getHeight()-3);
    }*/
  }
}
