/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.1
 * Changes 1.1:(Immo Schulz-Gerlach) 
 *  - Added CloneFromMe (overwritten)
 *  - added import base.*
 */
 
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.*;

public class ExtClass extends com.umlet.element.base.Class {
	
  public Entity CloneFromMe() {
    com.umlet.element.base.Class c=new ExtClass();
    c.setState(this.getPanelAttributes());
    //c.setVisible(true);
    c.setBounds(this.getBounds());
    return c;
  }	

	private Vector getStringVector() {
    Vector ret=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
    return ret;
  }
	
	public void paint(Graphics g) {
    Graphics2D g2=(Graphics2D) g;
    g2.setFont(Constants.getFont());
    
		Vector tmp=getStringVector();
		Composite[] composites = colorize(g2); //LME: enable colors
		
		//white box background
		g2.setColor(_fillColor);
		Rectangle r=this.getBounds();
		g.fillRect(0,0,(int)r.getWidth()-1,(int)r.getHeight()-1);
		//set the color for frames
		g2.setColor(_activeColor);
		
    //Constants.getFRC(g2);

		boolean bold=false, stroke=false;
    
		int i=0;
		while(i<tmp.size())
		{
			String StrTmp = (String) tmp.elementAt(i);
			if(StrTmp.equals("boldBorder"))
			{
				bold=true;
				tmp.remove(i);
			}
			
			else if(StrTmp.startsWith("lt="))
			{
				if(StrTmp.contains("."))
					stroke=true;
				
				if(StrTmp.contains("..") || StrTmp.contains("--") || StrTmp.contains("b"))
					bold=true;
					
				tmp.remove(i);
			}
			else
				i++;
		}

    int yPos=0;
    yPos+=Constants.getDistLineToText();

    boolean CENTER=true;
    for (i=0; i<tmp.size(); i++) {
      String s=(String)tmp.elementAt(i);
      if (s.equals("--")) {
        CENTER=false;
        g2.drawLine(0,yPos,this.getWidth(),yPos);
        yPos+=Constants.getDistLineToText();
      } else {
        yPos+=Constants.getFontsize();
        if (CENTER) {
          Constants.write(g2,s,(int)this.getWidth()/2, yPos, true);
        } else {
          Constants.write(g2,s,Constants.getFontsize()/2, yPos, false);
        }
        yPos+=Constants.getDistTextToText();
      }
    }

		//draw the (bold) round Rectangle
		if(bold && stroke)
			g2.setStroke(Constants.getStroke(1,2));
		else if(!bold && stroke)
			g2.setStroke(Constants.getStroke(1,1));
		else if(bold && !stroke)
			g2.setStroke(Constants.getStroke(0,2));
    //Rectangle r=this.getBounds();
    g.drawRect(0,0,(int)r.getWidth()-1,(int)r.getHeight()-1);
		g2.setStroke(Constants.getStroke(0,1));
	}
	
}