/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class FlowFinalNode extends com.umlet.element.base.Entity {

  // Change this method if you want to edit the graphical 
  // representation of your custom element.
  public void paint(Graphics g) {
    // Some unimportant initialization stuff; setting color, font 
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    Constants.getFRC(g2);


    // It's getting interesting here:
    // First, the strings you type in the element editor are read and
    // split into lines.
    // Then, by default, they are printed out on the element, aligned
    // to the left.
    // Change this to modify this default text printing and to react
    // to special strings
    // (like the "--" string in the UML class elements which draw a line).
    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		Composite[] composites = colorize(g2); //LME: enable colors
		g2.setColor(_activeColor);
		
    int yPos=(this.getHeight()/2)+ (Constants.getFontsize()/3);
    if (tmp.size()>0) {
      String s=(String)tmp.elementAt(0);
      Constants.write(g2,s,this.getWidth()/2, yPos, true);
    }


    // Finally, change other graphical attributes using
    // drawLine, getWidth, getHeight..
    int w = Math.min(this.getWidth()-1,this.getHeight()-1);
		int wdelta = (int)(w / 2 - (Math.cos(45.0 * Math.PI / 180.0) * w / 2)) + 1;
    g2.drawOval(0,0,w,w);
		
		//g2.drawLine(0,0,w,w);
		//g2.drawLine(w,0,0,w);
		g2.drawLine(wdelta,wdelta,w-wdelta,w-wdelta);
		g2.drawLine(w-wdelta,wdelta,wdelta,w-wdelta);
  }


  // Change this method if you want to set the resize-attributes of
  // your custom element
  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
  }


  // Advanced: change this method to modify the area where relations
  // stick to your custom element.
  public StickingPolygon getStickingBorder() {
    // By default, the element returns its outer borders. Change it,
    // if your element needs to stick to relations differently.
    // See, for example, the source code of the UML interface element.
    StickingPolygon p = new StickingPolygon();
    p.addLine(new Point(0,0), new Point(this.getWidth()-1,0),Constants.RESIZE_TOP);
    p.addLine(new Point(this.getWidth()-1,0), new Point(this.getWidth()-1,this.getHeight()-1),Constants.RESIZE_RIGHT);
    p.addLine(new Point(this.getWidth()-1,this.getHeight()-1), new Point(0,this.getHeight()-1),Constants.RESIZE_BOTTOM);
    p.addLine(new Point(0,this.getHeight()-1), new Point(0,0),Constants.RESIZE_LEFT);
    return p;
  }
}
