/**
 * @author Immo Schulz-Gerlach
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 * Changes:
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class KollaborationsNachrichten extends com.umlet.element.base.Entity {
	
  private void pfeilspitze(Graphics2D g2, int xSp, int ySp, int xBas, int yBas, boolean fill) {
	/* (xSp, ySP) ist der Punkt der Pfeilspitze,
	    (xBas, yBas) ist der Punkt auf der Pfeillinie, der von der Basis der Pfeilspitzendreiecks geschnitten wird. */
	
	//Berechne Eckpunkte des Dreiecks:
	int diffx = Math.abs(xSp-xBas);
	int diffy = Math.abs(ySp-yBas);
	
	int x1 = xBas - diffy/2;
	int y1 = yBas - diffx/2;
	int x2 = xBas + diffy/2;
	int y2 = yBas + diffx/2;
	if ( (xSp>xBas && ySp > yBas) || (xBas>xSp && yBas > ySp)) {
	  y1 = yBas+diffx/2;
	  y2 = yBas - diffx/2;
	}
	if (fill) {
		Polygon p = new Polygon();
		p.addPoint(xSp,ySp);
		p.addPoint(x1,y1);
		p.addPoint(x2,y2);
		g2.fillPolygon(p);
	} else {
		g2.drawLine(xSp,ySp,x1,y1);
		g2.drawLine(xSp,ySp,x2,y2);
	}
  }

  // Change this method if you want to edit the graphical 
  // representation of your custom element.
  public void paint(Graphics g) {

    // Some unimportant initialization stuff; setting color, font 
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    Constants.getFRC(g2);


    // It's getting interesting here:
    // First, the strings you type in the element editor are read and
    // split into lines.
    // Then, by default, they are printed out on the element, aligned
    // to the left.
    // Change this to modify this default text printing and to react
    // to special strings
    // (like the "--" string in the UML class elements which draw a line).
    char direction = '-';
    boolean gefuellt = true;
    boolean linksbuendig = false; 
    boolean tausch = false; //True kehrt die beiden Pfeilrichtungen um...
    Vector<String> text1 = new Vector<String>();
    Vector<String> text2 = new Vector<String>();
    boolean sektion1 = true;
	  
    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		Composite[] composites = colorize(g2); //LME: enable colors
		g2.setColor(_activeColor);
		
    int yPos=Constants.getDistLineToText();
    boolean isEmpty = tmp.size()<1;
    for (int i=0; i<tmp.size(); i++) {
      String s=(String)tmp.elementAt(i);
      if (s.startsWith("dir=")) {
	s = s.substring(4).trim();
	if (s.length()>0)
 {
		direction = s.charAt(0);
		s = s.substring(1).trim();
		if (s.equals(">"))
			gefuellt=false;
	}
      } else if (s.equals("swap"))
              tausch = true;
      else if (s.equals("alignleft"))
          linksbuendig=true;
      else if (s.equals("--"))
	      sektion1=false;
      else if (sektion1)
	      text1.add(s);
      else
	      text2.add(s);
    }  
      
      
      //yPos+=Constants.getFontsize();
      //Constants.write(g2,s,Constants.getFontsize()/2, yPos, false);
      //yPos+=Constants.getDistTextToText();
      
         //Ausgabe
        int xmid = this.getWidth()/2;
        int ymid = this.getHeight()/2;
	int pfeilHoehe = Constants.getDistLineToText()*4;
	if (direction=='|') {
		int xl = xmid - Constants.getDistLineToText()*4;
		int xr = xmid + Constants.getDistLineToText()*4;
		int yt = ymid - Constants.getFontsize();
		int yb = ymid + Constants.getFontsize();
		if (! text1.isEmpty()) { 
			// linken Pfeil zeichnen
			g2.drawLine(xl,yt,xl,yb);
			if (!tausch)
			  pfeilspitze(g2,xl,yt,xl,yt+pfeilHoehe,gefuellt);
			else
			  pfeilspitze(g2,xl,yb,xl,yb-pfeilHoehe,gefuellt);
			
			//Text
			int deltaX = 0;
			int deltaY = (Constants.getFontsize()+Constants.getDistTextToText())*text1.size();
			yPos = ymid - deltaY/2;
			Iterator<String> it = text1.iterator();
			if (linksbuendig) {
				while (it.hasNext())
					deltaX = Math.max(deltaX, Constants.getPixelWidth(g2,it.next()));
				it = text1.iterator();
			}
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xl - (linksbuendig? deltaX : Constants.getPixelWidth(g2,s))-pfeilHoehe,yPos,false);
				yPos+=Constants.getDistTextToText();
			}
			
		}
		if (! text2.isEmpty()) { 
			// rechten Pfeil zeichnen
			g2.drawLine(xr,yt,xr,yb);
			if (tausch)
			  pfeilspitze(g2,xr,yt,xr,yt+pfeilHoehe,gefuellt);
			else
			  pfeilspitze(g2,xr,yb,xr,yb-pfeilHoehe,gefuellt);
			
			//Text
			int deltaY = (Constants.getFontsize()+Constants.getDistTextToText())*text2.size();
			yPos = ymid - deltaY/2;
			Iterator<String> it = text2.iterator();
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xr+pfeilHoehe,yPos,false);
				yPos+=Constants.getDistTextToText();
			}
		}
	} else if (direction=='/') {
		int abstand = (int)(Math.sqrt (2)*Constants.getDistLineToText()*4);
		int pfeilDiag = (int)(pfeilHoehe / Math.sqrt(2));
		int xl = xmid - Constants.getDistLineToText()*2;
		int xr = xmid + Constants.getDistLineToText()*2;
		int yt = ymid - Constants.getDistLineToText()*2;
		int yb = ymid + Constants.getDistLineToText()*2;
		if (! text1.isEmpty()) { 
			// linken Pfeil zeichnen
			g2.drawLine(xl-abstand,yb,xr,yt-abstand);
			if (!tausch)
			  pfeilspitze(g2,xr,yt-abstand,xr-pfeilDiag,yt-abstand+pfeilDiag,gefuellt);
			else
			  pfeilspitze(g2,xl-abstand,yb,xl-abstand+pfeilDiag,yb-pfeilDiag,gefuellt); 
			
			//Text
			int deltaX = 0;
			int deltaY = (Constants.getFontsize()+Constants.getDistTextToText())*text1.size();
			yPos = yt - deltaY;
			Iterator<String> it = text1.iterator();
			if (linksbuendig) {
				while (it.hasNext())
					deltaX = Math.max(deltaX, Constants.getPixelWidth(g2,it.next()));
				it = text1.iterator();
			}
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xmid-abstand - (linksbuendig? deltaX : Constants.getPixelWidth(g2,s)),yPos,false);
				yPos+=Constants.getDistTextToText();
			}

			
		}
		if (! text2.isEmpty()) { 
			// rechten Pfeil zeichnen
			g2.drawLine(xl,yb+abstand,xr+abstand,yt);
			if (tausch)
			  pfeilspitze(g2,xr+abstand,yt,xr+abstand-pfeilDiag,yt+pfeilDiag,gefuellt);
			else
			  pfeilspitze(g2,xl,yb+abstand,xl+pfeilDiag,yb+abstand-pfeilDiag,gefuellt);
			
			//Text
			yPos = yb;
			Iterator<String> it = text2.iterator();
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xmid+abstand,yPos,false);
				yPos+=Constants.getDistTextToText();
			} 
		}
	} else if (direction=='\\') {
		int abstand = (int)(Math.sqrt (2)*Constants.getDistLineToText()*4);
		int pfeilDiag = (int)(pfeilHoehe / Math.sqrt(2));
		int xl = xmid - Constants.getDistLineToText()*2;
		int xr = xmid + Constants.getDistLineToText()*2;
		int yt = ymid - Constants.getDistLineToText()*2;
		int yb = ymid + Constants.getDistLineToText()*2;
		if (! text1.isEmpty()) { 
			// oberen/rechten Pfeil zeichnen
			g2.drawLine(xl,yt-abstand,xr+abstand,yb);
			if (!tausch)
			  pfeilspitze(g2,xr+abstand,yb,xr+abstand-pfeilDiag,yb-pfeilDiag,gefuellt);
			else
			  pfeilspitze(g2,xl,yt-abstand,xl+pfeilDiag,yt-abstand+pfeilDiag,gefuellt); 
			
			//Text
			int deltaY = (Constants.getFontsize()+Constants.getDistTextToText())*text1.size();
			yPos = yt - deltaY;
			Iterator<String> it = text1.iterator();
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xmid+abstand,yPos,false);
				yPos+=Constants.getDistTextToText();
			} 


			
		}
		if (! text2.isEmpty()) { 
			// unteren/linken Pfeil zeichnen
			g2.drawLine(xl-abstand,yt,xr,yb+abstand);
			if (tausch)
			  pfeilspitze(g2,xr,yb+abstand,xr-pfeilDiag,yb+abstand-pfeilDiag,gefuellt);
			else
			  pfeilspitze(g2,xl-abstand,yt,xl-abstand+pfeilDiag,yt+pfeilDiag,gefuellt);
			
			//Text
			int deltaX=0;
			yPos = yb;
			Iterator<String> it = text2.iterator();
			if (linksbuendig) {
				while (it.hasNext())
					deltaX = Math.max(deltaX, Constants.getPixelWidth(g2,it.next()));
				it = text2.iterator();
			}
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,xmid-abstand-(linksbuendig? deltaX : Constants.getPixelWidth(g2,s)),yPos,false);
				yPos+=Constants.getDistTextToText();
			}

		}
	} else {
		int yt = ymid - Constants.getDistLineToText()*4;
		int yb = ymid + Constants.getDistLineToText()*4;
		int xl = (linksbuendig? Constants.getFontsize() : xmid - Constants.getFontsize());
		int xr = (linksbuendig? Constants.getFontsize()*3 : xmid + Constants.getFontsize());
		if (! text1.isEmpty()) { 
			// oberen Pfeil zeichnen
			g2.drawLine(xl,yt,xr,yt);
			if (!tausch)
			  pfeilspitze(g2,xr,yt,xr-pfeilHoehe,yt,gefuellt);
			else
			  pfeilspitze(g2,xl,yt,xl+pfeilHoehe,yt,gefuellt);
			
			//Text
			int deltaY = (Constants.getFontsize()+Constants.getDistTextToText())*text1.size();
			yPos = yt - deltaY - pfeilHoehe;
			Iterator<String> it = text1.iterator();
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,(linksbuendig? 1 : xmid),yPos, !linksbuendig);
				yPos+=Constants.getDistTextToText();
			}
			
		}
		if (! text2.isEmpty()) { 
			// rechten Pfeil zeichnen
			g2.drawLine(xl,yb,xr,yb);
			if (tausch)
			  pfeilspitze(g2,xr,yb,xr-pfeilHoehe,yb,gefuellt);
			else
			  pfeilspitze(g2,xl,yb,xl+pfeilHoehe,yb,gefuellt);
			
			//Text
			yPos = yb + pfeilHoehe;
			Iterator<String> it = text2.iterator();
			while (it.hasNext()) {
				String s = it.next();
				yPos+=Constants.getFontsize();
				Constants.write(g2,s,(linksbuendig? 1 : xmid),yPos, !linksbuendig);
				yPos+=Constants.getDistTextToText();
			}
		}
	}

      
    


    // Finally, change other graphical attributes using
    // drawLine, getWidth, getHeight..
    if (_selected || isEmpty) {
      g2.drawLine(0,0,this.getWidth()-1,0);
      g2.drawLine(this.getWidth()-1, 0, this.getWidth()-1, this.getHeight()-1);
      g2.drawLine(this.getWidth()-1, this.getHeight()-1, 0, this.getHeight()-1);
      g2.drawLine(0, this.getHeight()-1, 0, 0);
    }
  }


  // Change this method if you want to set the resize-attributes of
  // your custom element
  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
  }


  // Advanced: change this method to modify the area where relations
  // stick to your custom element.
  public StickingPolygon getStickingBorder() {
    // By default, the element returns its outer borders. Change it,
    // if your element needs to stick to relations differently.
    // See, for example, the source code of the UML interface element.
    /*StickingPolygon p = new StickingPolygon();
    p.addLine(new Point(0,0), new Point(this.getWidth()-1,0),Constants.RESIZE_TOP);
    p.addLine(new Point(this.getWidth()-1,0), new Point(this.getWidth()-1,this.getHeight()-1),Constants.RESIZE_RIGHT);
    p.addLine(new Point(this.getWidth()-1,this.getHeight()-1), new Point(0,this.getHeight()-1),Constants.RESIZE_BOTTOM);
    p.addLine(new Point(0,this.getHeight()-1), new Point(0,0),Constants.RESIZE_LEFT);
    return p; */
    return null;
  }
}
