/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
import java.awt.*;
import java.awt.geom.Area;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.*;

public class OwnPackage extends com.umlet.element.base.Package
{
	
	private Vector<String> getStringVector() {
    Vector<String> ret=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
    return ret;
  }
	
	

	public void paint(Graphics g) {
    Graphics2D g2=(Graphics2D) g;
    g2.setFont(Constants.getFont());
    Composite[] composites = colorize(g2); //enable colors
    g2.setColor(_activeColor);
    Constants.getFRC(g2);

    Vector<String> tmp=new Vector<String>(getStringVector()); // in order to make the addition of "--" possible
    if (tmp.size()==0) tmp.add(" ");
    if (!tmp.contains("--")) tmp.add("--");

    int yPos=Constants.getDistLineToText();
    boolean borders=false;
    // G. Mueller start
    boolean normal=false;
    // int maxUpperBox=5*Constants.getFontsize();
    int maxUpperBox=(int)(this.getWidth()*0.4); // I think this looks better
    int lines = 0;
    
    int yPosBorder = yPos;

    //LME: coloring (some code doubled)
    for (int i=0; i<tmp.size(); i++) {
    	String s=tmp.elementAt(i);
    	if (tmp.elementAt(0).equals("--") && borders==false) yPosBorder = Constants.getDistLineToText()+Constants.getDistTextToText()+Constants.getFontsize(); // if there is no Packagename
    	if (s.equals("--") && borders==false) {
    		g2.setComposite(composites[1]);
    		g2.setColor(_fillColor);
    		//g2.fillRect(0,0,maxUpperBox,yPosBorder);
    		//g2.fillRect(0,yPosBorder,this.getWidth()-1,this.getHeight()-yPosBorder-1);
    		g2.setComposite(composites[0]);
    		if(_selected) g2.setColor(_activeColor);
    		else g2.setColor(_deselectedColor);

    		g2.drawRect(0,0,maxUpperBox,yPosBorder);
    		g2.drawRect(0,yPosBorder,this.getWidth()-1,this.getHeight()-yPosBorder-1);
    		// yPos to write the String centered
    		yPosBorder=Constants.getFontsize()/2+yPosBorder/2+this.getHeight()/2-(tmp.size()-lines)*(Constants.getFontsize()+Constants.getDistTextToText())/2;
    	} else if (!normal && i>1 && (tmp.elementAt(i-1).equals("--")&& tmp.elementAt(i).startsWith("left:"))) {
    		yPosBorder=(lines+1)*(Constants.getFontsize()+Constants.getDistTextToText())/2+Constants.getDistTextToText()+Constants.getFontsize()+Constants.getDistTextToText();
    	} else if (!borders){
    		maxUpperBox=Math.max(maxUpperBox,Constants.getPixelWidth(g2,s)+Constants.getFontsize());
    		yPosBorder+=Constants.getFontsize()+Constants.getDistTextToText();
    	} else if (normal) {
    		yPosBorder+=Constants.getFontsize()+Constants.getDistTextToText();
    	} else if(!normal){
    		yPosBorder+=Constants.getFontsize()+Constants.getDistTextToText();
    	}
    }
    
    
    for (int i=0; i<tmp.size(); i++) {
      String s=tmp.elementAt(i);
      
      if (tmp.elementAt(0).equals("--") && borders==false) yPos = Constants.getDistLineToText()+Constants.getDistTextToText()+Constants.getFontsize(); // if there is no Packagename
      
      if (s.equals("--") && borders==false) {
        borders=true;
//        g2.drawRect(0,0,maxUpperBox,yPos);
//        g2.drawRect(0,yPos,this.getWidth()-1,this.getHeight()-yPos-1);
        // yPos to write the String centered
        yPos=Constants.getFontsize()/2+yPos/2+this.getHeight()/2-(tmp.size()-lines)*(Constants.getFontsize()+Constants.getDistTextToText())/2;
      } else if (!normal && i>1 && (tmp.elementAt(i-1).equals("--")&& tmp.elementAt(i).startsWith("left:"))) {
          // writes the string normal
          yPos=(lines+1)*(Constants.getFontsize()+Constants.getDistTextToText())/2;
          yPos+=Constants.getDistTextToText();
          yPos+=Constants.getFontsize();
          Constants.write(g2,s.substring(5),Constants.getFontsize()/2, yPos, false);
          yPos+=Constants.getDistTextToText();
          normal = true;
      } else if (!borders){
          
          lines++;
          maxUpperBox=Math.max(maxUpperBox,Constants.getPixelWidth(g2,s)+Constants.getFontsize());
          yPos+=Constants.getFontsize();
          Constants.write(g2,s,Constants.getFontsize()/2, yPos, false);
          yPos+=Constants.getDistTextToText();
          
      } else if (normal) {
          
          yPos+=Constants.getFontsize();
          Constants.write(g2,s,Constants.getFontsize()/2, yPos, false);
          yPos+=Constants.getDistTextToText();
      
      } else if(!normal){
           
          yPos+=Constants.getFontsize();
          Constants.write(g2,s,(int)this.getWidth()/2, yPos, true);
          yPos+=Constants.getDistTextToText();
               
      }
      // G. Mueller End
    }

    /*Rectangle r=this.getBounds();
    g.drawRect(0,0,(int)r.getWidth()-1,(int)r.getHeight()-1);
    if (_selected) {
      g.drawRect(1,1,(int)r.getWidth()-3,(int)r.getHeight()-3);
    }*/
  }

	
}